/*------------------------------------------------------------------------------
#
#	GL View resources
#
------------------------------------------------------------------------------*/

#include "systypes.r"
#include "types.r"

#define  __kPrefSize	2000
#define  __kMinSize		500

#define CREATOR 'GlVw'
#define FCREATOR 'MPS '

type CREATOR {
	literal longint;
};

resource CREATOR (128, purgeable) {
	FCREATOR;
};

type CREATOR as 'STR ';

resource CREATOR (0) {
	"GL Graphics Viewer"
};


resource 'MENU' (20000, preload) {
	20000,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{	/* array: 2 elements */
		"About GLView", noIcon, noKey, noMark, plain,
		"-", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (20001, preload) {
	20001,
	textMenuProc,
	0x0,
	enabled,
	"File",
	{	/* array: 11 elements */
		"New", noIcon, "N", noMark, plain,
		"Open", noIcon, "O", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Close", noIcon, "W", noMark, plain,
		"Save", noIcon, "S", noMark, plain,
		"Save As", noIcon, noKey, noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Page Setup", noIcon, noKey, noMark, plain,
		"Print", noIcon, noKey, noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Quit", noIcon, "Q", noMark, plain
	}
};

resource 'MENU' (20002, preload) {
	20002,
	textMenuProc,
	0x0,
	enabled,
	"Edit",
	{	/* array: 6 elements */
		"Undo", noIcon, "Z", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Cut", noIcon, "X", noMark, plain,
		"Copy", noIcon, "C", noMark, plain,
		"Paste", noIcon, "V", noMark, plain,
		"Clear", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (20003, preload) {
	20003,
	textMenuProc,
	allEnabled,
	enabled,
	"Font",
	{	/* array: 0 elements */
	}
};

resource 'ALRT' (20001, purgeable) {
	{40, 20, 150, 260},
	20001,
	{	/* array: 4 elements */
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent
	}
};

resource 'ALRT' (20002, preload) {
	{72, 64, 212, 372},
	20002,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};

resource 'ALRT' (20000, purgeable) {
	{66, 58, 179, 270},
	20000,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};

resource 'DITL' (20001, purgeable) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{80, 150, 100, 230},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{10, 60, 60, 230},
		StaticText {
			disabled,
			"Error. ^0."
		},
		/* [3] */
		{8, 8, 40, 40},
		Icon {
			disabled,
			2
		}
	}
};

resource 'DITL' (20002, preload) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{58, 25, 76, 99},
		Button {
			enabled,
			"Yes"
		},
		/* [2] */
		{86, 25, 104, 99},
		Button {
			enabled,
			"No"
		},
		/* [3] */
		{12, 20, 45, 277},
		StaticText {
			disabled,
			"Save changes before closing?"
		},
		/* [4] */
		{86, 195, 104, 269},
		Button {
			enabled,
			"Cancel"
		}
	}
};

resource 'DITL' (20000, purgeable) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{83, 68, 103, 148},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{9, 72, 26, 137},
		StaticText {
			disabled,
			"GL View"
		},
		/* [3] */
		{35, 16, 75, 199},
		StaticText {
			disabled,
			"A viewer of PC  \"movie\" files in GL / Gr"
			"asp format."
		}
	}
};

resource 'DITL' (130) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{15, 51, 51, 196},
		StaticText {
			disabled,
			"Program requires a color display."
		},
		/* [2] */
		{15, 8, 47, 40},
		Icon {
			disabled,
			2
		}
	}
};

resource 'DITL' (133) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{14, 64, 55, 261},
		StaticText {
			disabled,
			"Program requires a Mac II processor (680"
			"20) or later."
		},
		/* [2] */
		{16, 19, 48, 51},
		Icon {
			disabled,
			2
		}
	}
};

resource 'CNTL' (20000, purgeable, preload) {
	{-1, 465, 272, 481},
	0,
	invisible,
	0,
	0,
	scrollBarProc,
	0,
	""
};

resource 'CNTL' (20001, purgeable, preload) {
	{271, -1, 287, 466},
	0,
	invisible,
	0,
	0,
	scrollBarProc,
	0,
	""
};

resource 'SIZE' (0) {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	not32BitCompatible,
	notHighLevelEventAware,
	onlyLocalHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	__kPrefSize * 1024,
	__kMinSize * 1024	
};

resource 'SIZE' (-1) {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	not32BitCompatible,
	notHighLevelEventAware,
	onlyLocalHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	__kPrefSize * 1024,
	__kMinSize * 1024	
};


resource 'MBAR' (20000, preload) {
	{	/* array MenuArray: 4 elements */
		/* [1] */
		20000,
		/* [2] */
		20001,
		/* [3] */
		20002,
		/* [4] */
		20003
	}
};

resource 'WIND' (20000, purgeable, preload) {
	{0, 0, 286, 480},
	zoomDocProc,
	invisible,
	noGoAway,
	0x0,
	"untitled"
};

resource 'STR#' (20000, purgeable) {
	{	/* array StringArray: 11 elements */
		/* [1] */
		"You must run on 512Ke or later",
		/* [2] */
		"Application Memory Size is too small",
		/* [3] */
		"Not enough memory to run SIOW",
		/* [4] */
		"Not enough memory to do Cut",
		/* [5] */
		"Cannot do Cut",
		/* [6] */
		"Cannot do Copy",
		/* [7] */
		"Cannot exceed 32,000 characters with Pas"
		"te",
		/* [8] */
		"Not enough memory to do Paste",
		/* [9] */
		"Cannot create window",
		/* [10] */
		"Cannot exceed 32,000 characters",
		/* [11] */
		"Cannot do PasteFont not found"
	}
};


resource 'BNDL' (128) {
	CREATOR,
	0,
	{
		'ICN#',
		{
			0, 128
		},
		'FREF',
		{
			0, 128
		}
	}
};


resource 'FREF' (128) {
	'APPL',
	0,
	""
};

resource 'ICN#' (128) {
	{	/* array: 2 elements */
		/* [1] */
		$"0000 0000 0000 0000 0010 4100 0010 2200"
		$"0020 2200 0020 2100 0020 4100 0010 4200"
		$"0010 4200 0010 2200 0020 2100 0020 0100"
		$"00FF FF00 03FF FFE0 0791 03F0 0ED1 0E7C"
		$"1C31 321C 380D C10E 3FFF FFFE 3003 C106"
		$"380D 300E 1E31 0E3C 1FC1 01F8 07FF FFE0"
		$"00FF FE",
		/* [2] */
		$"0000 0000 0000 0000 0010 4100 0010 2200"
		$"0020 2200 0020 2100 0020 4100 0010 4200"
		$"0010 4200 0010 2200 0020 2100 0020 0100"
		$"00FF FF00 03FF FFE0 07FF FFF0 0FFF FFFC"
		$"1FFF FFFC 3FFF FFFE 3FFF FFFE 3FFF FFFE"
		$"3FFF FFFE 1FFF FFFC 1FFF FFF8 07FF FFE0"
		$"00FF FE"
	}
};

resource 'DLOG' (130, "nocolor") {
	{62, 68, 132, 280},
	dBoxProc,
	visible,
	noGoAway,
	0x0,
	130,
	""
};

resource 'DLOG' (133, "no68020") {
	{62, 68, 133, 343},
	dBoxProc,
	visible,
	noGoAway,
	0x0,
	133,
	""
};

